import board  # Import board module to access pin names
import analogio# Import analogio to work with analog inputs/outputs
import digitalio
import time  # Import time module to handle delays
import usb_hid
from adafruit_hid.keyboard import Keyboard
from adafruit_hid.keycode import Keycode

button = digitalio.DigitalInOut(board.D7)  # Define button on pin D7
button.direction = digitalio.Direction.INPUT  # Set as an input (reading data)
button.pull = digitalio.Pull.UP  # Enable internal pull-up resistor (default HIGH)

# Variable to track previous button state
previous_state = button.value  # Start by storing the initial button state

keyboard = Keyboard(usb_hid.devices)

pot_x = analogio.AnalogIn(board.A0)
pot_y = analogio.AnalogIn(board.A1)
pot_z = analogio.AnalogIn(board.A2)

center = 65535 // 2 # The center of the pot
neutral_zone = 10000 # Area on pot where there is no input

while True:
    pot_value_x = pot_x.value
    deviation_x = pot_value_x - center

    pot_value_y = pot_y.value
    deviation_y = pot_value_y - center

    pot_value_z = pot_z.value
    deviation_z = pot_value_z - center
    
    current_state = button.value

    if previous_state and not current_state:
        keyboard.press(Keycode.HOME)
        keyboard.press(Keycode.SHIFT, Keycode.C)
    keyboard.release_all()
    
    previous_state = current_state

    print(pot_value_x)

    if abs(deviation_x) > neutral_zone: #abs is removing negitave values
        
        if deviation_x > 0:
            keyboard.press(Keycode.KEYPAD_SIX)
            #keyboard.press(Keycode.KEYPAD_EIGHT)
            print(pot_value_x)
        else:
            keyboard.press(Keycode.KEYPAD_FOUR)
            #keyboard.press(Keycode.KEYPAD_TWO)
            print(pot_value_x)
    else:
        keyboard.release(Keycode.KEYPAD_SIX)
        keyboard.release(Keycode.KEYPAD_FOUR)

    print(pot_value_y)

    if abs(deviation_y) > neutral_zone: #abs is removing negitave values
        
        if deviation_y > 0:
            keyboard.press(Keycode.KEYPAD_EIGHT)
            #keyboard.press(Keycode.KEYPAD_EIGHT)
            print(pot_value_y)
        else:
            keyboard.press(Keycode.KEYPAD_TWO)
            #keyboard.press(Keycode.KEYPAD_TWO)
            print(pot_value_y)
    else:
        keyboard.release(Keycode.KEYPAD_EIGHT)
        keyboard.release(Keycode.KEYPAD_TWO)

    print(pot_value_z)

    if abs(deviation_z) > neutral_zone: #abs is removing negitave values
        
        if deviation_z > 0:
            keyboard.press(Keycode.KEYPAD_PLUS)
            #keyboard.press(Keycode.KEYPAD_EIGHT)
            print(pot_value_z)
        else:
            keyboard.press(Keycode.KEYPAD_MINUS)
            #keyboard.press(Keycode.KEYPAD_TWO)
            print(pot_value_z)
    else:
        keyboard.release(Keycode.KEYPAD_PLUS)
        keyboard.release(Keycode.KEYPAD_MINUS)
 
    time.sleep(0.001)
